searchNodes=[{"doc":"EctoAnon provides a simple way to handle data anonymization directly in your Ecto schemas.","ref":"EctoAnon.html","title":"EctoAnon","type":"module"},{"doc":"Updates an Ecto struct with anonymized data based on its anon_schema declaration. It also updates any embedded schema declared in anon_schema. defmodule User do use Ecto.Schema use EctoAnon.Schema anon_schema [ :firstname , email : &amp; __MODULE__ . anonymized_email / 3 birthdate : [ :anonymized_date , options : [ :only_year ] ] ] schema &quot;user&quot; do field :fistname , :string field :email , :string field :birthdate , :utc_datetime end def anonymized_email ( _type , _value , _opts ) do &quot;xxx@xxx.com&quot; end end It returns {:ok, struct} if the struct has been successfully updated or {:error, :non_anonymizable_struct} if the struct has no anonymizable fields. Options :cascade - When set to true , allows ecto_anon to preload and anonymize all associations (and associations of these associations) automatically in cascade. Could be used to anonymize all data related a struct in a single call. Note that this won't traverse belongs_to associations to avoid infinite and cyclic anonymizations. Default: false :log - When set to true , it will set anonymized field when EctoAnon.run applies anonymization on a ressource. Default: true Example defmodule User do use Ecto.Schema use EctoAnon.Schema anon_schema [ :email ] schema &quot;users&quot; do field :name , :string field :age , :integer , default : 0 field :email , :string end end By default, an anon_field will be anonymized with a default value based on its type: iex&gt; user = Repo . get ( User , id ) % User { name : &quot;jane&quot; , age : 0 , email : &quot;jane@email.com&quot; } iex&gt; EctoAnon . run ( user , Repo ) { :ok , % User { name : &quot;jane&quot; , age : 0 , email : &quot;redacted&quot; } }","ref":"EctoAnon.html#run/3","title":"EctoAnon.run/3","type":"function"},{"doc":"","ref":"EctoAnon.Anonymizer.html","title":"EctoAnon.Anonymizer","type":"module"},{"doc":"","ref":"EctoAnon.Anonymizer.html#anonymized_data/1","title":"EctoAnon.Anonymizer.anonymized_data/1","type":"function"},{"doc":"","ref":"EctoAnon.Anonymizer.html#is_association?/2","title":"EctoAnon.Anonymizer.is_association?/2","type":"function"},{"doc":"","ref":"EctoAnon.Anonymizer.html#is_embed?/2","title":"EctoAnon.Anonymizer.is_embed?/2","type":"function"},{"doc":"","ref":"EctoAnon.Migration.html","title":"EctoAnon.Migration","type":"module"},{"doc":"Adds anonymized column (boolean) to a table. This column can be used to track if the resource has be anonymized or not. defmodule MyApp.Repo.Migrations.CreateUser do use Ecto.Migration import EctoAnon.Migration def change do create table ( :users ) do add :firstname , :string add :lastname , :string timestamps ( ) anonymized ( ) end end end","ref":"EctoAnon.Migration.html#anonymized/0","title":"EctoAnon.Migration.anonymized/0","type":"function"},{"doc":"","ref":"EctoAnon.Query.html","title":"EctoAnon.Query","type":"module"},{"doc":"","ref":"EctoAnon.Query.html#apply/3","title":"EctoAnon.Query.apply/3","type":"function"},{"doc":"Returns a query that searches resources excluding anonymized ones query = from ( u in User , select : u ) |&gt; not_anonymized results = Repo . all ( query )","ref":"EctoAnon.Query.html#not_anonymized/1","title":"EctoAnon.Query.not_anonymized/1","type":"function"},{"doc":"","ref":"EctoAnon.Query.html#set_anonymized/2","title":"EctoAnon.Query.set_anonymized/2","type":"function"},{"doc":"EctoAnon.Schema lets you define anonymizable fields.","ref":"EctoAnon.Schema.html","title":"EctoAnon.Schema","type":"module"},{"doc":"Macro to declare anonymizable fields","ref":"EctoAnon.Schema.html#anon_schema/1","title":"EctoAnon.Schema.anon_schema/1","type":"macro"},{"doc":"Macro to create an anonymized field in the schema","ref":"EctoAnon.Schema.html#anonymized/0","title":"EctoAnon.Schema.anonymized/0","type":"macro"},{"doc":"This module is in charge of the function attribution.","ref":"EctoAnon.Functions.html","title":"EctoAnon.Functions","type":"behaviour"},{"doc":"Returns the anonymization function based on passed argument","ref":"EctoAnon.Functions.html#get_function/1","title":"EctoAnon.Functions.get_function/1","type":"function"},{"doc":"Returns the anonymization module based on passed argument","ref":"EctoAnon.Functions.html#get_module/1","title":"EctoAnon.Functions.get_module/1","type":"function"},{"doc":"","ref":"EctoAnon.Functions.html#c:run/3","title":"EctoAnon.Functions.run/3","type":"callback"},{"doc":"Anonymizing module for a date, accepting types: date utc_datetime utc_datetime_usec naive_datetime naive_datetime_usec","ref":"EctoAnon.Functions.AnonymizedDate.html","title":"EctoAnon.Functions.AnonymizedDate","type":"module"},{"doc":"Returns an anonymized date/datetime Options :only_year - When set to true , it keeps the year while anonymizing the rest Example { :ok , date } = Date . new ( 2019 , 02 , 04 ) AnonymizedDate . run ( :date , date , [ :only_year ] ) ~D[2019-01-01] AnonymizedDate . run ( :utc_datetime , date , [ :only_year ] ) ~U[2019-01-01 00:00:00Z] AnonymizedDate . run ( :utc_datetime_usec , date , [ :only_year ] ) ~U[2019-01-01 00:00:00.000000Z] AnonymizedDate . run ( :naive_datetime , date , [ :only_year ] ) ~N[2019-01-01 00:00:00] AnonymizedDate . run ( :naive_datetime_usec , date , [ :only_year ] ) ~N[2019-01-01 00:00:00.000000] AnonymizedDate . run ( :date , date ) ~D[1970-01-01]","ref":"EctoAnon.Functions.AnonymizedDate.html#run/3","title":"EctoAnon.Functions.AnonymizedDate.run/3","type":"function"},{"doc":"Anonymizing module for an email","ref":"EctoAnon.Functions.AnonymizedEmail.html","title":"EctoAnon.Functions.AnonymizedEmail","type":"module"},{"doc":"Returns an anonymized email with hashes while keeping the email format Options :partial - When set to true , it keeps the first character of each part and hides the rest Example AnonymizedEmail . run ( :string , &quot;john.doe@email.com&quot; , [ ] ) &quot;5d526ea414@a717679b0f.com&quot; AnonymizedEmail . run ( :string , &quot;not_an_email&quot; , [ ] ) &quot;c2fd076ad9@c2fd076ad9.com&quot; AnonymizedEmail . run ( :string , &quot;john.doe@email.com&quot; , partial : true ) &quot;j******@e******.com&quot;","ref":"EctoAnon.Functions.AnonymizedEmail.html#run/3","title":"EctoAnon.Functions.AnonymizedEmail.run/3","type":"function"},{"doc":"Anonymizing module for a phone number Currently only returns with french format","ref":"EctoAnon.Functions.AnonymizedPhone.html","title":"EctoAnon.Functions.AnonymizedPhone","type":"module"},{"doc":"Returns a phone number anonymized with french format Example AnonymizedPhone . run ( :string , &quot;0601020304&quot; , [ ] ) &quot;xx xx xx xx xx&quot;","ref":"EctoAnon.Functions.AnonymizedPhone.html#run/3","title":"EctoAnon.Functions.AnonymizedPhone.run/3","type":"function"},{"doc":"Default anonymizing functions for basic Ecto types.","ref":"EctoAnon.Functions.Default.html","title":"EctoAnon.Functions.Default","type":"module"},{"doc":"Returns default anonymized value based on field type @default_integer 0 @default_float 0.0 @default_string &quot;redacted&quot; @default_map %{ } @default_decimal Decimal . new ( &quot;0.0&quot; ) @default_date ~D[1970-01-01] @default_datetime ~U[1970-01-01 00:00:00Z] @default_datetime_usec ~U[1970-01-01 00:00:00.000000Z] @default_naive_datetime ~N[1970-01-01 00:00:00] @default_naive_datetime_usec ~N[1970-01-01 00:00:00.000000] @default_time ~T[00:00:00] @default_time_usec ~T[00:00:00.000000]","ref":"EctoAnon.Functions.Default.html#run/3","title":"EctoAnon.Functions.Default.run/3","type":"function"},{"doc":"","ref":"EctoAnon.Functions.Helpers.html","title":"EctoAnon.Functions.Helpers","type":"module"},{"doc":"","ref":"EctoAnon.Functions.Helpers.html#generate_hash/1","title":"EctoAnon.Functions.Helpers.generate_hash/1","type":"function"},{"doc":"Genererates a random uuid version 4","ref":"EctoAnon.Functions.RandomUuid.html","title":"EctoAnon.Functions.RandomUuid","type":"module"},{"doc":"Returns a random version 4 UUID Example RandomUuid . run ( :string , &quot;0601020304&quot; , [ ] ) &quot;71d8ed69-31ca-4b9d-826b-f355ea7fb128&quot;","ref":"EctoAnon.Functions.RandomUuid.html#run/3","title":"EctoAnon.Functions.RandomUuid.run/3","type":"function"},{"doc":"Simple way to handle data anonymization directly in your Ecto schemas","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Installation Usage Schema Migrations Options Contributing Testing License Installation Add :ecto_anon to your mix.exs dependencies: def deps do [ { :ecto_anon , &quot;~&gt; 0.1.0&quot; } ] end Usage Define an anon_schema with all fields you want to be anonymized in your schema module defmodule User do use Ecto.Schema use EctoAnon.Schema anon_schema [ :email ] schema &quot;users&quot; do field :name , :string field :age , :integer field :email , :string end end Then use EctoAnon.run to apply anonymization on desired resource user = Repo . get ( User , id ) % User { name : &quot;jane&quot; , age : 0 , email : &quot;jane@email.com&quot; } EctoAnon . run ( user , Repo ) { :ok , % User { name : &quot;jane&quot; , age : 0 , email : &quot;redacted&quot; } }","ref":"readme.html#table-of-contents","title":"Overview - Table of Contents","type":"extras"},{"doc":"Declare an anon_schema with all fields you want to anonymize (regular fields, associations, embeds) defmodule User do use Ecto.Schema use EctoAnon.Schema anon_schema [ :email ] schema &quot;users&quot; do field :name , :string field :age , :integer field :email , :string anonymized ( ) end end By adding a anonymized field in your migration , you can add anonymized() in your schema just like timestamps() . Default values By default, a field will be anonymized with a default value based on its type type value integer 0 float 0.0 string redacted map %{} decimal Decimal . new ( &quot; 0.0 &quot; ) date ~D[ 1970-01-01 ] datetime ~U[ 1970-01-01 00:00:00Z ] datetime_usec ~U[ 1970-01-01 00:00:00.000000Z ] naive_datetime ~N[ 1970-01-01 00:00:00 ] naive_datetime_usec ~N[ 1970-01-01 00:00:00.000000 ] time ~T[ 00:00:00 ] time_usec ~T[ 00:00:00.000000 ] boolean no change id no change binary_id no change binary no change Native anonymization functions anon_schema ( [ email : :anonymized_email , birthdate : [ :anonymized_date , options : [ :only_year ] ] ] ) Natively, ecto_anon embeds differents functions to suit your needs function role options :anonymized_date Anonymizes partially or completely a date/datetime :only_year :anonymized_email Anonymizes partially or completely an email :partial :anonymized_phone Anonymizes a phone number (currently only FR) :random_uuid Returns a random UUID Custom functions anon_schema ( [ address : &amp; __MODULE__ . anonymized_address / 3 ] ) def anonymized_address ( :map , %{ } = address , _opts \\\\ [ ] ) do address |&gt; Map . drop ( [ &quot;street&quot; ] ) end You can also pass custom functions with the following signature: function(type, value, options)","ref":"readme.html#schema","title":"Overview - Schema","type":"extras"},{"doc":"By importing EctoAnon.Migration in your ecto migration file, you can add an anonymized() macro that will generate an anonymized boolean field in your table: defmodule MyApp.Repo.Migrations.CreateUser do use Ecto.Migration import EctoAnon.Migration def change do create table ( :users ) do add :firstname , :string add :lastname , :string timestamps ( ) anonymized ( ) end end end Combined with log option when executing the anonymization, it will allow you to identify anonymized rows and exclude them in your queries with EctoAnon.Query.not_anonymized/1 .","ref":"readme.html#migrations","title":"Overview - Migrations","type":"extras"},{"doc":"cascade When set to true , allows ecto-anon to preload and anonymize all associations (and associations of these associations) automatically in cascade. Could be used to anonymize all data related a struct in a single call. Note that this won't traverse belongs_to associations. Default: false log When set to true , it will set anonymized field when EctoAnon.run applies anonymization on a ressource. Default: true","ref":"readme.html#options","title":"Overview - Options","type":"extras"},{"doc":"Copyright (c) 2022 CORUSCANT (Welcome to the Jungle) - https://www.welcometothejungle.com This library is licensed under the MIT","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"},{"doc":"The MIT License Copyright (c) 2022 CORUSCANT (Welcome to the Jungle) - https://www.welcometothejungle.com Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"}]